"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.moidLink = void 0;
const deepmerge_1 = __importDefault(require("deepmerge"));
const e_1 = require("e");
const fs_1 = require("fs");
const node_fetch_1 = __importDefault(require("node-fetch"));
const types_1 = require("../dist/meta/types");
const Items_1 = __importStar(require("../dist/structures/Items"));
const util_1 = require("../dist/util");
const manualItemChanges_1 = require("./manualItemChanges");
const equipmentModifications = new Map();
const equipmentModSrc = [
    ['Pink stained full helm', 'Bronze full helm'].map(util_1.itemID),
    ['Pink stained platebody', 'Bronze platebody'].map(util_1.itemID),
    ['Pink stained platelegs', 'Bronze platelegs'].map(util_1.itemID),
    ['Bulging sack', 'Red cape'].map(util_1.itemID)
];
for (const [toChange, toCopy] of equipmentModSrc) {
    equipmentModifications.set(toChange, toCopy);
}
const itemNameMap = {};
function itemShouldntBeAdded(item) {
    var _a;
    return (Items_1.USELESS_ITEMS.includes(item.id) ||
        item.duplicate === true ||
        item.noted ||
        item.linked_id_item ||
        item.placeholder ||
        item.name === 'Null' ||
        ((_a = item.wiki_name) === null || _a === void 0 ? void 0 : _a.includes(' (Worn)')));
}
function moidLink(items) {
    return `https://chisel.weirdgloop.org/moid/item_id.html#${items.map(i => i.id).join(',')}`;
}
exports.moidLink = moidLink;
function getItem(name) {
    const item = Items_1.default.get(name);
    if (!item)
        throw new Error(`${name} doesnt exist`);
    return item;
}
const manualItems = [
    {
        id: 28329,
        name: 'Ring of shadows',
        members: true,
        equipable: true,
        equipable_by_player: true,
        cost: 75000,
        lowalch: 30000,
        highalch: 45000,
        weight: 0.004,
        release_date: '2023-07-26',
        examine: 'A powerful ring used to see into other realms...',
        wiki_name: 'Ring of shadows (uncharged)',
        wiki_url: 'https://oldschool.runescape.wiki/w/Ring_of_shadows#Uncharged',
        equipment: {
            attack_stab: 4,
            attack_slash: 4,
            attack_crush: 4,
            attack_magic: 5,
            attack_ranged: 4,
            defence_stab: 0,
            defence_slash: 0,
            defence_crush: 0,
            defence_magic: 5,
            defence_ranged: 0,
            melee_strength: 2,
            ranged_strength: 0,
            magic_damage: 0,
            prayer: 2,
            slot: types_1.EquipmentSlot.Ring,
            requirements: null
        },
        price: 0
    },
    {
        id: 28409,
        name: 'Ancient lamp',
        cost: 1,
        weight: 0.1,
        release_date: '2023-07-26',
        examine: 'Good for rubbing.',
        wiki_name: 'Ancient lamp',
        wiki_url: 'https://oldschool.runescape.wiki/w/Ancient_lamp',
        price: 0
    },
    {
        id: 27897,
        name: 'Scaly blue dragonhide',
        members: true,
        tradeable: true,
        tradeable_on_ge: true,
        noteable: true,
        cost: 100,
        lowalch: 40,
        highalch: 60,
        weight: 3.175,
        release_date: '2023-05-17',
        examine: 'A scaled blue dragonhide.',
        wiki_name: 'Scaly blue dragonhide',
        wiki_url: 'https://oldschool.runescape.wiki/w/Scaly_blue_dragonhide',
        price: 2011
    }
];
// Make these all worth 0gp. They're manipulated and fluctuate hugely constantly.
const itemsToIgnorePrices = [
    'Raw bird meat',
    'Red feather',
    'Yellow feather',
    'Orange feather',
    'Blue feather',
    'Stripy feather',
    'Ferret',
    'Ruby harvest',
    'Sapphire glacialis',
    'Snowy knight',
    'Black warlock',
    'Kebbit claws',
    'Barb-tail harpoon',
    'Kebbit spike',
    'Kebbit teeth',
    'Damaged monkey tail',
    'Monkey tail',
    'Spotted kebbit fur',
    'Dark kebbit fur',
    'Dashing kebbit fur',
    'Imp-in-a-box(2)',
    'Swamp lizard',
    'Orange salamander',
    'Red salamander',
    'Black salamander',
    'Larupia fur',
    'Tatty larupia fur',
    'Graahk fur',
    'Tatty graahk fur',
    'Kyatt fur',
    'Tatty kyatt fur',
    'Raw rabbit',
    'Rabbit foot',
    'Polar kebbit fur',
    'Raw beast meat',
    'Common kebbit fur',
    'Feldip weasel fur',
    'Desert devil fur',
    'Long kebbit spike',
    'Fish food',
    'Iron bolts (p+)',
    'Cream boots',
    'Brandy',
    'Premade sgg',
    'Spicy crunchies',
    'Premade veg batta',
    'Assorted flowers',
    'Purple hat',
    "Blood'n'tar snelm",
    "Blood'n'tar snelm",
    'Fremennik brown cloak',
    'Fremennik brown shirt',
    'Shirt',
    'Steel arrow(p++)',
    'Spider on shaft',
    'Tribal mask',
    'White dagger',
    'Sandstone (5kg)',
    'Minced meat',
    'Bagged dead tree',
    'Kitchen table',
    'Teak bed ',
    'Bandana eyepatch',
    'Iron bolts (p+)',
    'Elemental helmet',
    'Butterfly net',
    'Light orb',
    'Steel hasta',
    'Defence mix(2)',
    'Arceuus banner',
    'Yellow cape',
    'Iron spear(p+)',
    'Egg and tomato',
    "Druid's robe top",
    'Bronze thrownaxe',
    'Steel thrownaxe',
    'Iron javelin(p)',
    'Black longsword',
    "Premade s'y crunch",
    'Redberry pie',
    'Serum 207 (2)',
    'Fremennik red shirt',
    'Dwellberry seed',
    'Iron javelin(p++)',
    'Steel knife(p+)',
    'Mithril dagger(p++)',
    'Thatch spar dense',
    'Villager armband',
    'Sliced mushrooms',
    'Raw fish pie',
    "Blue d'hide chaps (g)",
    'Oak armchair',
    'Teak armchair',
    'Beer barrel',
    'Carved oak bench',
    'Carved teak bench',
    'Oak stock',
    'Oak toy box',
    'Teak magic wardrobe',
    'Oak armour case',
    'Roast beast meat',
    "Relicym's mix(2)",
    'Antidote+ mix(1)'
]
    .map(getItem)
    .map(i => i.id);
const keysToWarnIfRemovedOrAdded = ['equipable', 'equipment', 'weapon'];
function prepareItems() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    return __awaiter(this, void 0, void 0, function* () {
        const messages = [];
        const allItemsRaw = yield (0, node_fetch_1.default)('https://raw.githubusercontent.com/0xNeffarion/osrsreboxed-db/master/docs/items-complete.json').then((res) => res.json());
        const allItems = (0, e_1.deepClone)(allItemsRaw);
        const allPrices = yield (0, node_fetch_1.default)('https://prices.runescape.wiki/api/v1/osrs/latest', {
            headers: {
                'User-Agent': 'oldschooljs - @magnaboy'
            }
        })
            .then((res) => res.json())
            .then(res => res.data);
        if (!allPrices[20997]) {
            throw new Error('Failed to fetch prices');
        }
        const newItems = [];
        const majorPriceChanges = [];
        const previousItems = JSON.parse((0, fs_1.readFileSync)('./src/data/items/item_data.json', 'utf-8'));
        for (let item of Object.values(allItems)) {
            if (itemShouldntBeAdded(item))
                continue;
            if (item.name === "Pharaoh's sceptre") {
                item = Object.assign(Object.assign({}, allItems[26950]), { id: item.id });
            }
            for (const delKey of [
                'quest_item',
                'placeholder',
                'duplicate',
                'last_updated',
                'icon',
                'noted',
                'linked_id_item',
                'linked_id_noted',
                'linked_id_placeholder',
                'stacked',
                'quest_item'
            ]) {
                // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                // @ts-ignore
                delete item[delKey];
            }
            for (const boolKey of [
                'incomplete',
                'members',
                'tradeable',
                'tradeable_on_ge',
                'stackable',
                'noteable',
                'equipable',
                'equipable_by_player',
                'equipable_weapon',
                'weight',
                'buy_limit',
                'release_date',
                'examine',
                'wiki_name',
                'wiki_url',
                'equipment',
                'weapon'
            ]) {
                if (!item[boolKey]) {
                    delete item[boolKey];
                }
            }
            if (item.lowalch === null)
                delete item.lowalch;
            if (item.highalch === null)
                delete item.highalch;
            const previousItem = Items_1.default.get(item.id);
            if (!previousItem) {
                newItems.push(item);
            }
            const price = allPrices[item.id];
            if (price) {
                item.price = Math.max(0, (price.high + price.low) / 2);
            }
            else {
                item.price = 0;
            }
            if (item.id === 995) {
                item.price = 1;
            }
            if (itemsToIgnorePrices.includes(item.id) || !item.tradeable) {
                item.price = 0;
            }
            // If major price increase, just dont fucking change it.
            if (previousItem && item.tradeable && previousItem.price < item.price / 20 && previousItem.price !== 0) {
                majorPriceChanges.push([previousItem, item]);
                item.price = previousItem.price;
            }
            // Dont change price if its only a <10% difference and price is less than 100k
            if (previousItem &&
                item.price > (0, e_1.reduceNumByPercent)(previousItem === null || previousItem === void 0 ? void 0 : previousItem.price, 10) &&
                item.price < (0, e_1.increaseNumByPercent)(previousItem === null || previousItem === void 0 ? void 0 : previousItem.price, 10) &&
                item.price < 100000) {
                item.price = previousItem.price;
            }
            else if (
            // Ignore <3% changes in any way
            previousItem &&
                item.price > (0, e_1.reduceNumByPercent)(previousItem === null || previousItem === void 0 ? void 0 : previousItem.price, 3) &&
                item.price < (0, e_1.increaseNumByPercent)(previousItem === null || previousItem === void 0 ? void 0 : previousItem.price, 3)) {
                item.price = previousItem.price;
            }
            if (previousItem) {
                for (const key of keysToWarnIfRemovedOrAdded) {
                    if (!item[key] && Boolean(previousItem === null || previousItem === void 0 ? void 0 : previousItem[key])) {
                        messages.push(`WARNING: ${item.name} (${item.id}) had ${key} removed`);
                    }
                    if (!previousItem[key] && Boolean(item === null || item === void 0 ? void 0 : item[key])) {
                        messages.push(`WARNING: ${item.name} (${item.id}) had ${key} added`);
                    }
                }
                if (item.name !== previousItem.name) {
                    messages.push(`WARNING: name changed from ${previousItem.name} to ${item.name}`);
                }
                if (((_a = item.equipment) === null || _a === void 0 ? void 0 : _a.slot) !== ((_b = previousItem.equipment) === null || _b === void 0 ? void 0 : _b.slot)) {
                    messages.push(`WARNING: ${previousItem.name} slot changed`);
                }
            }
            if (equipmentModifications.has(item.id)) {
                const copyItem = Items_1.default.get(equipmentModifications.get(item.id));
                item.equipment = copyItem.equipment;
                item.equipable_by_player = copyItem.equipable_by_player;
                item.equipable_weapon = copyItem.equipable_weapon;
                item.equipable = copyItem.equipable;
            }
            if (previousItem) {
                item.cost = previousItem.cost;
                item.lowalch = previousItem.lowalch;
                item.highalch = previousItem.highalch;
                item.wiki_url = previousItem.wiki_url;
                item.wiki_name = previousItem.wiki_name;
                item.release_date = previousItem.release_date;
                if ((_c = previousItem.equipment) === null || _c === void 0 ? void 0 : _c.requirements) {
                    // @ts-ignore ignore
                    item.equipment = Object.assign(Object.assign({}, item.equipment), { requirements: previousItem.equipment.requirements });
                }
            }
            if (previousItem) {
                if (((_d = item.equipment) === null || _d === void 0 ? void 0 : _d.requirements) === null && ((_e = previousItem.equipment) === null || _e === void 0 ? void 0 : _e.requirements) !== null) {
                    messages.push(`WARNING: ${item.name} (${item.id}) had requirements removed: BEFORE[${JSON.stringify((_f = previousItem.equipment) === null || _f === void 0 ? void 0 : _f.requirements)}] AFTER[${JSON.stringify((_g = item.equipment) === null || _g === void 0 ? void 0 : _g.requirements)}]`);
                }
                else if (JSON.stringify((_h = item.equipment) === null || _h === void 0 ? void 0 : _h.requirements) !== JSON.stringify((_j = previousItem.equipment) === null || _j === void 0 ? void 0 : _j.requirements)) {
                    messages.push(`WARNING: ${item.name} (${item.id}) had requirements changed: BEFORE[${JSON.stringify((_k = previousItem.equipment) === null || _k === void 0 ? void 0 : _k.requirements)}] AFTER[${JSON.stringify((_l = item.equipment) === null || _l === void 0 ? void 0 : _l.requirements)}]`);
                }
            }
            if (((_m = previousItem === null || previousItem === void 0 ? void 0 : previousItem.equipment) === null || _m === void 0 ? void 0 : _m.requirements) && !((_o = item.equipment) === null || _o === void 0 ? void 0 : _o.requirements)) {
                // @ts-ignore ignore
                item.equipment = Object.assign(Object.assign({}, item.equipment), { requirements: previousItem.equipment.requirements });
            }
            if (manualItemChanges_1.itemChanges[item.id]) {
                item = (0, deepmerge_1.default)(item, manualItemChanges_1.itemChanges[item.id]);
            }
            itemNameMap[item.id] = item;
            for (const item of manualItems) {
                itemNameMap[item.id] = item;
            }
        }
        const deletedItems = Object.values(previousItems)
            .filter((i) => !itemNameMap[i.id])
            .filter(e_1.notEmpty);
        messages.push(`New Items: ${moidLink(newItems)}.`);
        messages.push(`Deleted Items: ${moidLink(deletedItems)}.`);
        const sql = `SELECT 
  ${deletedItems
            .map(item => `COUNT(*) FILTER (WHERE bank->>'${item.id}' IS NOT NULL) AS people_with_item_${item.id},
  SUM((bank->>'${item.id}')::int) AS sum_item_${item.id},`)
            .join('\n')}

FROM users;
`;
        messages.push(`${sql}`);
        messages.push(`Major price changes NOT changed: ${majorPriceChanges
            .map(ent => `${ent[0].name} (${ent[0].price} to ${ent[1].price})`)
            .join(', ')}.`);
        (0, fs_1.writeFileSync)('./src/data/items/item_data.json', JSON.stringify(itemNameMap, null, 4));
        (0, fs_1.writeFileSync)('./updates.txt', messages.join('\n'));
        messages.push('Prepared items.');
    });
}
exports.default = prepareItems;
//# sourceMappingURL=prepareItems.js.map