"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const node_fetch_1 = __importDefault(require("node-fetch"));
const dist_1 = require("../dist");
const monsterMap = {};
function prepareMonsters() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v;
    return __awaiter(this, void 0, void 0, function* () {
        const allMonsters = yield (0, node_fetch_1.default)('https://raw.githubusercontent.com/0xNeffarion/osrsreboxed-db/master/docs/monsters-complete.json').then((res) => res.json());
        const monIDs = new Set(dist_1.Monsters.map(mon => mon.id));
        for (const mon of Object.values(allMonsters).filter(mon => monIDs.has(mon.id))) {
            // @ts-ignore ignore
            delete mon.drops;
            const newMonster = {
                members: mon.members,
                combatLevel: mon.combat_level,
                hitpoints: mon.hitpoints,
                maxHit: mon.max_hit,
                attackType: mon.attack_type,
                attackSpeed: mon.attack_speed,
                aggressive: mon.aggressive,
                poisonous: mon.poisonous,
                immuneToPoison: mon.immune_poison,
                immuneToVenom: mon.immune_venom,
                attributes: (_a = mon.attributes) !== null && _a !== void 0 ? _a : [],
                category: mon.category,
                examineText: mon.examine,
                wikiName: mon.wiki_name,
                wikiURL: mon.wiki_url,
                attackLevel: mon.attack_level,
                strengthLevel: mon.strength_level,
                defenceLevel: mon.defence_level,
                magicLevel: mon.magic_level,
                rangedLevel: mon.ranged_level,
                attackStab: (_b = mon.attack_stab) !== null && _b !== void 0 ? _b : 0,
                attackSlash: (_c = mon.attack_slash) !== null && _c !== void 0 ? _c : 0,
                attackCrush: (_d = mon.attack_crush) !== null && _d !== void 0 ? _d : 0,
                attackMagic: (_e = mon.attack_magic) !== null && _e !== void 0 ? _e : 0,
                attackRanged: (_f = mon.attack_ranged) !== null && _f !== void 0 ? _f : 0,
                defenceStab: (_g = mon.defence_stab) !== null && _g !== void 0 ? _g : 0,
                defenceSlash: (_h = mon.defence_slash) !== null && _h !== void 0 ? _h : 0,
                defenceCrush: (_j = mon.defence_crush) !== null && _j !== void 0 ? _j : 0,
                defenceMagic: (_k = mon.defence_magic) !== null && _k !== void 0 ? _k : 0,
                defenceRanged: (_l = mon.defence_ranged) !== null && _l !== void 0 ? _l : 0,
                attackAccuracy: (_m = mon.attack_accuracy) !== null && _m !== void 0 ? _m : 0,
                meleeStrength: (_o = mon.melee_strength) !== null && _o !== void 0 ? _o : 0,
                rangedStrength: (_p = mon.ranged_strength) !== null && _p !== void 0 ? _p : 0,
                magicDamage: (_q = mon.magic_damage) !== null && _q !== void 0 ? _q : 0,
                isSlayerMonster: mon.slayer_monster,
                slayerLevelRequired: (_r = mon.slayer_level) !== null && _r !== void 0 ? _r : 0,
                slayerXP: (_s = mon.slayer_xp) !== null && _s !== void 0 ? _s : 0,
                assignableSlayerMasters: (_t = mon.slayer_masters) !== null && _t !== void 0 ? _t : []
            };
            monsterMap[mon.id] = newMonster;
            if (mon.name.toLowerCase() !== ((_u = dist_1.Monsters.get(mon.id)) === null || _u === void 0 ? void 0 : _u.name.toLowerCase())) {
                console.warn(`Warning: Name of ${mon.name} does not match ${(_v = dist_1.Monsters.get(mon.id)) === null || _v === void 0 ? void 0 : _v.name}`);
            }
        }
        monsterMap[12192] = Object.assign({}, monsterMap[12191]);
        monsterMap[12215] = Object.assign({}, monsterMap[12214]);
        monsterMap[12205] = Object.assign({}, monsterMap[12204]);
        monsterMap[12224] = Object.assign({}, monsterMap[12223]);
        (0, fs_1.writeFileSync)('./src/data/monsters_data.json', JSON.stringify(monsterMap, null, 4));
        console.log('Prepared Monsters. Check any new monsters quickly to see that the data looks okay.');
    });
}
prepareMonsters();
//# sourceMappingURL=prepareMonsters.js.map