"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = require("fs");
const dist_1 = require("../dist");
const currentNews = JSON.parse((0, fs_1.readFileSync)('./src/data/news/news_archive.json').toString());
function prepareNews() {
    return __awaiter(this, void 0, void 0, function* () {
        const newArticles = yield dist_1.News.fetchNewArticles();
        console.log(`Found ${newArticles ? newArticles.length : 0} news articles to be added.`);
        if (newArticles) {
            (0, fs_1.writeFileSync)('./src/data/news/news_archive.json', JSON.stringify([...currentNews, ...newArticles.sort((a, b) => a.date - b.date)], null, 4));
        }
        console.log('Prepared news.');
    });
}
exports.default = prepareNews;
//# sourceMappingURL=prepareNews.js.map