"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
(0, vitest_1.test)('Hiscores', () => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b;
    const koru = yield src_1.Hiscores.fetch('Koru');
    (0, vitest_1.expect)(koru.minigames.pvpArena.rank).toBeGreaterThanOrEqual(1);
    (0, vitest_1.expect)(koru.minigames.pvpArena.score).toBeGreaterThanOrEqual(1);
    (0, vitest_1.expect)(koru.bossRecords.commanderZilyana.score).toBeGreaterThanOrEqual(1);
    (0, vitest_1.expect)(koru.bossRecords.dagannothPrime.score).toBeGreaterThanOrEqual(1);
    (0, vitest_1.expect)(koru.bossRecords.dagannothRex.score).toBeGreaterThanOrEqual(1);
    const [lynxTitan, zulu, magnaboy, virtualMagnaboy, dmmTournyFaux] = yield Promise.all([
        src_1.Hiscores.fetch('Lynx Titan'),
        src_1.Hiscores.fetch('Zulu'),
        src_1.Hiscores.fetch('Magnaboy'),
        src_1.Hiscores.fetch('Magnaboy', { virtualLevels: true }),
        src_1.Hiscores.fetch('Faux', { virtualLevels: true })
    ]);
    (0, vitest_1.expect)(lynxTitan.username).toBe('Lynx Titan');
    (0, vitest_1.expect)(lynxTitan.combatLevel).toBe(126);
    (0, vitest_1.expect)(lynxTitan.skills.overall.level).toBe(2277);
    (0, vitest_1.expect)(lynxTitan.skills.overall.xp).toBe(4600000000);
    (0, vitest_1.expect)(lynxTitan.clues.hard.score >= 22).toBe(true);
    (0, vitest_1.expect)(typeof lynxTitan.minigames.bountyHunter.rank).toBe('number');
    (0, vitest_1.expect)(zulu.bossRecords.giantMole.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.commanderZilyana.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.commanderZilyana.score).toBeGreaterThan(1084);
    (0, vitest_1.expect)(zulu.bossRecords.zulrah.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.zulrah.score).toBeGreaterThanOrEqual(2527);
    (0, vitest_1.expect)(zulu.bossRecords.callisto.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.callisto.score).toBeGreaterThan(326);
    (0, vitest_1.expect)(zulu.bossRecords.cerberus.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.cerberus.score).toBeGreaterThan(7079);
    (0, vitest_1.expect)(zulu.bossRecords.nex.rank > 1).toBe(true);
    (0, vitest_1.expect)(zulu.bossRecords.nex.score > 150 && zulu.bossRecords.nex.score < 3000).toBe(true);
    (0, vitest_1.expect)(magnaboy.clues.all.score).toBe(157);
    (0, vitest_1.expect)(magnaboy.clues.beginner.score).toBe(6);
    (0, vitest_1.expect)(magnaboy.clues.easy.score).toBe(15);
    (0, vitest_1.expect)(magnaboy.clues.medium.score).toBe(60);
    (0, vitest_1.expect)(magnaboy.clues.hard.score).toBe(53);
    (0, vitest_1.expect)(magnaboy.clues.elite.score).toBe(16);
    (0, vitest_1.expect)(magnaboy.clues.master.score).toBe(7);
    (0, vitest_1.expect)(magnaboy.minigames.LMS.score).toBe(-1);
    (0, vitest_1.expect)(magnaboy.bossRecords.nex.score).toBe(-1);
    (0, vitest_1.expect)(magnaboy.minigames.riftsClosed.score).toBe(-1);
    (0, vitest_1.expect)(virtualMagnaboy.skills.firemaking.level).toBe(106);
    (0, vitest_1.expect)(virtualMagnaboy.skills.cooking.level).toBe(100);
    (0, vitest_1.expect)(virtualMagnaboy.skills.fletching.level).toBe(99);
    (0, vitest_1.expect)(virtualMagnaboy.leaguePoints).toEqual(undefined);
    // DMM Tourny
    (0, vitest_1.expect)(dmmTournyFaux.username).toEqual('Faux');
    // Dont die Faux
    (0, vitest_1.expect)(dmmTournyFaux.combatLevel).toBeGreaterThan(30);
    (0, vitest_1.expect)(dmmTournyFaux.skills.agility.level).toBeGreaterThan(49);
    const leagues = yield src_1.Hiscores.fetch('Magnaboy', { type: 'seasonal' });
    (0, vitest_1.expect)((_a = leagues.leaguePoints) === null || _a === void 0 ? void 0 : _a.points).toBeGreaterThan(1);
    const leagues2 = yield src_1.Hiscores.fetch('fk ezscape', { type: 'seasonal' });
    (0, vitest_1.expect)((_b = leagues2.leaguePoints) === null || _b === void 0 ? void 0 : _b.points).toBeGreaterThan(1);
    // Skillers
    const skiller = yield src_1.Hiscores.fetch('Jcw', { type: 'skiller' });
    (0, vitest_1.expect)(skiller.skills.overall.rank).toBeLessThan(10);
    (0, vitest_1.expect)(skiller.skills.overall.level).toBeGreaterThan(1500);
    (0, vitest_1.expect)(skiller.skills.overall.level).toBeLessThan(1601);
    // Pures
    const pure = yield src_1.Hiscores.fetch('Headline', { type: 'skiller_defence' });
    (0, vitest_1.expect)(pure.skills.overall.rank).toBe(1);
    (0, vitest_1.expect)(pure.skills.overall.level).toBe(2179);
}), 30000);
//# sourceMappingURL=Hiscores.test.js.map