"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
(0, vitest_1.describe)('News', () => {
    (0, vitest_1.test)('Generic checks', () => __awaiter(void 0, void 0, void 0, function* () {
        vitest_1.expect.assertions(1);
        const firstPageNews = src_1.News.filter(article => article.year === 2013 && article.month === 2);
        (0, vitest_1.expect)(firstPageNews.size).toEqual(12);
    }));
    (0, vitest_1.test)('Single article check', () => {
        vitest_1.expect.assertions(4);
        const article = src_1.News.find(article => article.title === 'GameBlast15 | Friday 12:00 UTC | Live Stream');
        if (!article)
            throw new Error('Missing article.');
        (0, vitest_1.expect)(article.category).toEqual('Website');
        (0, vitest_1.expect)(article.link).toEqual('https://secure.runescape.com/m=news/gameblast15--friday-1200-utc--live-stream?oldschool=1');
        (0, vitest_1.expect)(article.year).toEqual(2015);
        (0, vitest_1.expect)(article.month).toEqual(2);
    });
});
//# sourceMappingURL=News.test.js.map