"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
const util_1 = require("../src/util");
(0, vitest_1.describe)('Openables', () => {
    (0, vitest_1.test)('allItems', () => {
        const allItems = src_1.Openables.array()
            .map(i => i.allItems)
            .flat(Infinity);
        for (const item of ['Mystic hat (dusk)', 'Broken dragon hasta', 'Dragonstone full helm'].map(util_1.itemID)) {
            (0, vitest_1.expect)(allItems.includes(item)).toEqual(true);
        }
    });
    (0, vitest_1.test)('allItems', () => {
        for (const [key, val] of src_1.Openables.entries()) {
            if (val.allItems.length === 0) {
                console.error(`${key} has no allitems`);
            }
        }
    });
});
//# sourceMappingURL=Openables.test.js.map