"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const misc_1 = require("../src/simulation/misc");
(0, vitest_1.test)('Chambers Of Xeric', () => __awaiter(void 0, void 0, void 0, function* () {
    vitest_1.expect.assertions(3);
    const maxRoll = 570000 * (1 / 8675);
    (0, vitest_1.expect)(misc_1.ChambersOfXeric.determineUniqueChancesFromTeamPoints(570000)).toEqual([maxRoll]);
    (0, vitest_1.expect)(misc_1.ChambersOfXeric.determineUniqueChancesFromTeamPoints(855000)).toEqual([
        maxRoll,
        855000 * (1 / 8675) - maxRoll
    ]);
    (0, vitest_1.expect)(misc_1.ChambersOfXeric.determineUniqueChancesFromTeamPoints(73000000)).toEqual([maxRoll, maxRoll, maxRoll]);
}));
//# sourceMappingURL=Raids.test.js.map