"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
(0, vitest_1.describe)('Wiki', () => {
    (0, vitest_1.test)('Searching', () => __awaiter(void 0, void 0, void 0, function* () {
        vitest_1.expect.assertions(2);
        const searchResults = yield src_1.Wiki.search('tbow');
        const twistedBow = searchResults[0];
        (0, vitest_1.expect)(twistedBow.title).toEqual('Twisted bow');
        (0, vitest_1.expect)(searchResults.length).toBeGreaterThanOrEqual(4);
    }));
    (0, vitest_1.test)('Random', () => __awaiter(void 0, void 0, void 0, function* () {
        vitest_1.expect.assertions(2);
        const fiveRandom = yield src_1.Wiki.random(5);
        const twentyRandom = yield src_1.Wiki.random(20);
        (0, vitest_1.expect)(fiveRandom.length).toEqual(5);
        (0, vitest_1.expect)(twentyRandom.length).toEqual(20);
    }));
    (0, vitest_1.test)('Fetching by ID', () => __awaiter(void 0, void 0, void 0, function* () {
        vitest_1.expect.assertions(1);
        const twistedBowPage = yield src_1.Wiki.fetchPage(82098);
        if (!twistedBowPage)
            throw new Error('Failed to fetch page');
        (0, vitest_1.expect)(twistedBowPage.title).toEqual('Twisted bow');
    }));
});
//# sourceMappingURL=Wiki.test.js.map