"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
(0, vitest_1.describe)('Worlds', () => {
    (0, vitest_1.beforeAll)(() => __awaiter(void 0, void 0, void 0, function* () {
        yield src_1.Worlds.fetch();
    }));
    (0, vitest_1.test)('Generic Worlds', () => {
        vitest_1.expect.assertions(2);
        // New worlds are sometimes added, so just check it has atleast the amount of normal worlds.
        (0, vitest_1.expect)(src_1.Worlds.size >= 180).toBeTruthy();
        // There should be more than 14 Australian Worlds.
        const australianWorlds = src_1.Worlds.filter(world => world.location === 'Australia');
        (0, vitest_1.expect)(australianWorlds.size > 14).toBeTruthy();
    });
    (0, vitest_1.test)('Single world should be correct', () => {
        vitest_1.expect.assertions(3);
        const WorldOne = src_1.Worlds.get(301);
        if (!WorldOne)
            throw new Error('World One not found.');
        (0, vitest_1.expect)(WorldOne.number).toEqual(301);
        (0, vitest_1.expect)(WorldOne.location).toEqual('United States');
        (0, vitest_1.expect)(WorldOne.activity).toEqual('Trade - Free');
    });
    (0, vitest_1.test)('Getting worlds in different formats', () => {
        vitest_1.expect.assertions(2);
        (0, vitest_1.expect)(src_1.Worlds.get(301)).toEqual(src_1.Worlds.get(1));
        (0, vitest_1.expect)(src_1.Worlds.get(230)).toEqual(src_1.Worlds.get(530));
    });
});
//# sourceMappingURL=Worlds.test.js.map