"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const src_1 = require("../src");
(0, vitest_1.test)('Items Sanity Test', () => __awaiter(void 0, void 0, void 0, function* () {
    const item27624 = src_1.Items.get(27624);
    (0, vitest_1.expect)(item27624.id).toEqual(27624);
    (0, vitest_1.expect)(item27624.name).toEqual('Ancient sceptre');
    (0, vitest_1.expect)(item27624.members).toEqual(true);
    (0, vitest_1.expect)(item27624.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27624.equipable).toEqual(true);
    (0, vitest_1.expect)(item27624.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27624.noteable).toBeUndefined();
    (0, vitest_1.expect)(item27624.cost).toEqual(211000);
    // expect(item27624.lowalch).toBeUndefined();
    // expect(item27624.highalch).toBeUndefined();
    (0, vitest_1.expect)(item27624.weight).toEqual(2.267);
    (0, vitest_1.expect)(item27624.buy_limit).toBeUndefined();
    (0, vitest_1.expect)(item27624.release_date).toEqual('2023-01-11');
    (0, vitest_1.expect)(item27624.examine).toEqual('A very old and powerful stick.');
    const item27626 = src_1.Items.get(27626);
    (0, vitest_1.expect)(item27626.id).toEqual(27626);
    (0, vitest_1.expect)(item27626.name).toEqual('Ancient sceptre (l)');
    (0, vitest_1.expect)(item27626.members).toEqual(true);
    (0, vitest_1.expect)(item27626.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27626.equipable).toEqual(true);
    (0, vitest_1.expect)(item27626.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27626.noteable).toBeUndefined();
    (0, vitest_1.expect)(item27626.cost).toEqual(211000);
    // expect(item27626.lowalch).toBeUndefined();
    // expect(item27626.highalch).toBeUndefined();
    (0, vitest_1.expect)(item27626.weight).toEqual(2.267);
    (0, vitest_1.expect)(item27626.buy_limit).toBeUndefined();
    (0, vitest_1.expect)(item27626.release_date).toEqual('2023-01-11');
    (0, vitest_1.expect)(item27626.examine).toEqual('A very old and powerful stick.');
    const item27612 = src_1.Items.get(27612);
    (0, vitest_1.expect)(item27612.id).toEqual(27612);
    (0, vitest_1.expect)(item27612.name).toEqual('Venator bow (uncharged)');
    (0, vitest_1.expect)(item27612.members).toEqual(true);
    (0, vitest_1.expect)(item27612.tradeable).toEqual(true);
    (0, vitest_1.expect)(item27612.equipable).toEqual(true);
    (0, vitest_1.expect)(item27612.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27612.cost).toEqual(750000);
    (0, vitest_1.expect)(item27612.lowalch).toEqual(300000);
    (0, vitest_1.expect)(item27612.highalch).toEqual(450000);
    (0, vitest_1.expect)(item27612.buy_limit).toBeUndefined();
    const item27610 = src_1.Items.get(27610);
    (0, vitest_1.expect)(item27610.id).toEqual(27610);
    (0, vitest_1.expect)(item27610.name).toEqual('Venator bow');
    (0, vitest_1.expect)(item27610.members).toEqual(true);
    (0, vitest_1.expect)(item27610.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27610.equipable).toEqual(true);
    (0, vitest_1.expect)(item27610.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27610.noteable).toBeUndefined();
    (0, vitest_1.expect)(item27610.cost).toEqual(750000);
    (0, vitest_1.expect)(item27610.lowalch).toEqual(300000);
    (0, vitest_1.expect)(item27610.highalch).toEqual(450000);
    (0, vitest_1.expect)(item27610.buy_limit).toBeUndefined();
    const itemWebweaverBowU = src_1.Items.get(27652);
    (0, vitest_1.expect)(itemWebweaverBowU.id).toEqual(27652);
    (0, vitest_1.expect)(itemWebweaverBowU.name).toEqual('Webweaver bow (u)');
    (0, vitest_1.expect)(itemWebweaverBowU.members).toEqual(true);
    (0, vitest_1.expect)(itemWebweaverBowU.tradeable).toEqual(true);
    (0, vitest_1.expect)(itemWebweaverBowU.equipable).toEqual(true);
    (0, vitest_1.expect)(itemWebweaverBowU.stackable).toBeUndefined();
    (0, vitest_1.expect)(itemWebweaverBowU.noteable).toEqual(true);
    (0, vitest_1.expect)(itemWebweaverBowU.cost).toEqual(175000);
    (0, vitest_1.expect)(itemWebweaverBowU.lowalch).toEqual(70000);
    (0, vitest_1.expect)(itemWebweaverBowU.highalch).toEqual(105000);
    const item27655 = src_1.Items.get(27655);
    (0, vitest_1.expect)(item27655.id).toEqual(27655);
    (0, vitest_1.expect)(item27655.name).toEqual('Webweaver bow');
    (0, vitest_1.expect)(item27655.members).toEqual(true);
    (0, vitest_1.expect)(item27655.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27655.equipable).toEqual(true);
    (0, vitest_1.expect)(item27655.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27655.cost).toEqual(175000);
    (0, vitest_1.expect)(item27655.lowalch).toEqual(70000);
    (0, vitest_1.expect)(item27655.highalch).toEqual(105000);
    (0, vitest_1.expect)(item27655.buy_limit).toBeUndefined();
    const item27657 = src_1.Items.get(27657);
    (0, vitest_1.expect)(item27657.id).toEqual(27657);
    (0, vitest_1.expect)(item27657.name).toEqual('Ursine chainmace (u)');
    (0, vitest_1.expect)(item27657.members).toEqual(true);
    (0, vitest_1.expect)(item27657.tradeable).toEqual(true);
    (0, vitest_1.expect)(item27657.equipable).toEqual(true);
    (0, vitest_1.expect)(item27657.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27657.cost).toEqual(175000);
    (0, vitest_1.expect)(item27657.lowalch).toEqual(70000);
    (0, vitest_1.expect)(item27657.highalch).toEqual(105000);
    const item27660 = src_1.Items.get(27660);
    (0, vitest_1.expect)(item27660.id).toEqual(27660);
    (0, vitest_1.expect)(item27660.name).toEqual('Ursine chainmace');
    (0, vitest_1.expect)(item27660.members).toEqual(true);
    (0, vitest_1.expect)(item27660.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27660.equipable).toEqual(true);
    (0, vitest_1.expect)(item27660.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27660.cost).toEqual(175000);
    (0, vitest_1.expect)(item27660.lowalch).toEqual(70000);
    (0, vitest_1.expect)(item27660.highalch).toEqual(105000);
    (0, vitest_1.expect)(item27660.buy_limit).toBeUndefined();
    const item27662 = src_1.Items.get(27662);
    (0, vitest_1.expect)(item27662.id).toEqual(27662);
    (0, vitest_1.expect)(item27662.name).toEqual('Accursed sceptre (u)');
    (0, vitest_1.expect)(item27662.members).toEqual(true);
    (0, vitest_1.expect)(item27662.tradeable).toEqual(true);
    (0, vitest_1.expect)(item27662.equipable).toEqual(true);
    (0, vitest_1.expect)(item27662.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27662.buy_limit).toBeUndefined();
    const item27665 = src_1.Items.get(27665);
    (0, vitest_1.expect)(item27665.id).toEqual(27665);
    (0, vitest_1.expect)(item27665.name).toEqual('Accursed sceptre');
    (0, vitest_1.expect)(item27665.members).toEqual(true);
    (0, vitest_1.expect)(item27665.tradeable).toBeUndefined();
    (0, vitest_1.expect)(item27665.equipable).toEqual(true);
    (0, vitest_1.expect)(item27665.stackable).toBeUndefined();
    (0, vitest_1.expect)(item27665.buy_limit).toBeUndefined();
    (0, vitest_1.expect)(item27665.equipment.requirements.magic).toEqual(70);
}), 30000);
//# sourceMappingURL=items.sanity.test.js.map